﻿Imports System
Imports System.IO
Imports System.Text
Imports System.Runtime.InteropServices
Imports System.Management


Module Module1
    Public srcPath As String
    Public dstPath As String

    'フォルダ選択
    Public Function SelectFolder(ByVal fm As Form, ByVal defolt As String) As String
        Dim ret As String = ""

        'FolderBrowserDialogクラスのインスタンスを作成
        Dim fbd As New FolderBrowserDialog
        fbd.Description = "フォルダを指定してください。"
        fbd.RootFolder = Environment.SpecialFolder.Desktop
        'RootFolder以下にあるフォルダである必要がある
        fbd.SelectedPath = defolt
        fbd.ShowNewFolderButton = True

        If fbd.ShowDialog(fm) = DialogResult.OK Then
            ret = fbd.SelectedPath
        End If
        Return ret

    End Function

    Public Function SelectFiles(ByVal defolt As String) As String()
        'OpenFileDialogクラスのインスタンスを作成
        Dim ofd As New OpenFileDialog()

        ofd.FileName = "default.ts"
        ofd.InitialDirectory = defolt
        ofd.Filter = "tsファイル(*.ts)|*.ts|全てのファイル(*.*)|*.*"
        ofd.FilterIndex = 1
        ofd.Title = "ファイルを選択してください"
        'ダイアログボックスを閉じる前に現在のディレクトリを復元するようにする
        ofd.RestoreDirectory = True
        '存在しないファイルの名前が指定されたとき警告を表示する
        ofd.CheckFileExists = True
        '存在しないパスが指定されたとき警告を表示する
        ofd.CheckPathExists = True
        ofd.Multiselect = True

        'ダイアログを表示する
        If ofd.ShowDialog() = DialogResult.OK Then
            Return ofd.FileNames
        End If

        Return Nothing

    End Function

    <System.Runtime.InteropServices.DllImport("kernel32", _
       CharSet:=System.Runtime.InteropServices.CharSet.Auto)> _
    Function GetLastError() As Integer
    End Function

    ' スナップショットを取得する関数の宣言
    <System.Runtime.InteropServices.DllImport("kernel32", _
        CharSet:=System.Runtime.InteropServices.CharSet.Auto)> _
    Function CreateToolhelp32Snapshot( _
        ByVal dwFlag As Int32, _
        ByVal th32ProcessID As Int32) As Int32
    End Function

    ' どの部分をスナップショットに含めたいかを示す定数の宣言
    Public Const TH32CS_SNAPPROCESS = &H2&
    ' パス名の最大長を定義
    Public Const MAX_PATH = 260

    ' プロセスエントリを定義する構造体
    <StructLayout(LayoutKind.Sequential)> _
    Public Structure PROCESSENTRY32
        Public dwSize As Int32
        Public cntUsage As Int32
        Public th32ProcessID As Int32
        Public th32DefaultHeapID As Int32
        Public th32ModuleID As Int32
        Public cntThreads As Int32
        Public th32ParentProcessID As Int32
        Public pcPriClassBase As Int32
        Public dwFlags As Int32
        'Public szExeFile(MAX_PATH - 1) As Byte
        <MarshalAs(UnmanagedType.ByValTStr, SizeConst:=260)> Public szExeFile As String
    End Structure

    <StructLayout(LayoutKind.Sequential)> _
    Public Structure LUID
        Public LowPart As Int32
        Public HighPart As Int32
    End Structure

    <StructLayout(LayoutKind.Sequential)> _
    Public Structure LUID_AND_ATTRIBUTES
        Public pLuid As LUID
        Public Attributes As Int32
    End Structure

    <StructLayout(LayoutKind.Sequential)> _
    Public Structure TOKEN_PRIVILEGES
        Public PrivilegeCount As Int32
        Public TheLuid As LUID
        Public Attributes As Int32
    End Structure

    ' 最初のプロセスに関する情報を取得する関数の宣言
    <System.Runtime.InteropServices.DllImport("kernel32", _
        CharSet:=System.Runtime.InteropServices.CharSet.Ansi)> _
    Function Process32First( _
             ByVal hSnapshot As Int32, _
             ByRef lppe As PROCESSENTRY32) As Int32
    End Function

    ' 2番目以降のプロセスに関する情報を取得する関数の宣言
    <System.Runtime.InteropServices.DllImport("kernel32", _
       CharSet:=System.Runtime.InteropServices.CharSet.Ansi)> _
    Function Process32Next( _
             ByVal hSnapshot As Int32, _
             ByRef lppe As PROCESSENTRY32) As Int32
    End Function

    ' オープンされているオブジェクトハンドルを
    ' クローズする関数の宣言
    <System.Runtime.InteropServices.DllImport("kernel32", _
       CharSet:=System.Runtime.InteropServices.CharSet.Auto)> _
    Function CloseHandle( _
             ByVal hObject As Int32) As Int32

    End Function

    <System.Runtime.InteropServices.DllImport("kernel32", _
       CharSet:=System.Runtime.InteropServices.CharSet.Auto)> _
    Function OpenProcess( _
             ByVal dwDesiredAccess As Int32, _
             ByVal bInheritHandle As Int32, _
             ByVal dwProcessId As Int32) As Int32

    End Function

    <System.Runtime.InteropServices.DllImport("kernel32", _
       CharSet:=System.Runtime.InteropServices.CharSet.Auto)> _
    Function TerminateProcess( _
             ByVal hProcess As Int32, _
             ByVal uExitCode As Int32) As Int32

    End Function

    <System.Runtime.InteropServices.DllImport("user32.dll", _
       CharSet:=System.Runtime.InteropServices.CharSet.Auto)> _
    Function GetWindowThreadProcessId( _
             ByVal hwnd As Int32, _
             ByVal lpdwProcessId As Int32) As Int32

    End Function

    <System.Runtime.InteropServices.DllImport("advapi32.dll", _
      CharSet:=System.Runtime.InteropServices.CharSet.Auto)> _
    Function AdjustTokenPrivileges( _
             ByVal TokenHandle As Int32, _
             ByVal DisableAllPrivileges As Int32, _
             ByRef NewState As TOKEN_PRIVILEGES, _
             ByVal BufferLength As Int32, _
             ByRef PreviousState As TOKEN_PRIVILEGES, _
             ByVal ReturnLength As Int32) As Int32

    End Function

    <System.Runtime.InteropServices.DllImport("advapi32.dll", _
     CharSet:=System.Runtime.InteropServices.CharSet.Auto)> _
    Function OpenProcessToken( _
             ByVal ProcessHandle As Int32, _
             ByVal DesiredAccess As Int32, _
             ByVal TokenHandle As Int32) As Int32

    End Function

    <System.Runtime.InteropServices.DllImport("advapi32.dll", _
     CharSet:=System.Runtime.InteropServices.CharSet.Auto)> _
    Function LookupPrivilegeValue( _
             ByVal lpSystemName As String, _
             ByVal lpName As String, _
             ByRef lpLuid As LUID) As Int32

    End Function

    <System.Runtime.InteropServices.DllImport("kernel32.dll", _
     CharSet:=System.Runtime.InteropServices.CharSet.Auto)> _
    Function GetCurrentProcess() As Int32

    End Function

    'Function ProcessTerminate(Optional lProcessID As int32, Optional lHwndWindow As int32) As Boolean
    Function ProcessTerminate(ByVal lProcessID As Int32) As Boolean
        Dim lhwndProcess As Int32
        Dim lExitCode As Int32
        Dim lRetVal As Int32
        Dim lhThisProc As Int32
        Dim lhTokenHandle As Int32
        Dim tLuid As LUID
        Dim tTokenPriv As TOKEN_PRIVILEGES, tTokenPrivNew As TOKEN_PRIVILEGES
        Dim lBufferNeeded As Int32

        Const PROCESS_ALL_ACCESS = &H1F0FFF, PROCESS_TERMINATE = &H1
        Const ANYSIZE_ARRAY = 1, TOKEN_ADJUST_PRIVILEGES = &H20
        Const TOKEN_QUERY = &H8, SE_DEBUG_NAME As String = "SeDebugPrivilege"
        Const SE_PRIVILEGE_ENABLED = &H2

        On Error Resume Next
        'If lHwndWindow Then
        '    'Get the process ID from the window handle
        '    lRetVal = GetWindowThreadProcessId(lHwndWindow, lProcessID)
        'End If

        If lProcessID Then
            'Give Kill permissions to this process
            lhThisProc = GetCurrentProcess()

            OpenProcessToken(lhThisProc, TOKEN_ADJUST_PRIVILEGES Or TOKEN_QUERY, lhTokenHandle)
            LookupPrivilegeValue("", SE_DEBUG_NAME, tLuid)
            'Set the number of privileges to be change
            tTokenPriv.PrivilegeCount = 1
            tTokenPriv.TheLuid = tLuid
            tTokenPriv.Attributes = SE_PRIVILEGE_ENABLED
            'Enable the kill privilege in the access token of this process
            AdjustTokenPrivileges(lhTokenHandle, False, tTokenPriv, Len(tTokenPrivNew), tTokenPrivNew, lBufferNeeded)

            'Open the process to kill
            lhwndProcess = OpenProcess(PROCESS_TERMINATE, 0, lProcessID)

            If lhwndProcess Then
                'Obtained process handle, kill the process
                ProcessTerminate = CBool(TerminateProcess(lhwndProcess, lExitCode))
                Call CloseHandle(lhwndProcess)
            End If
        End If
        On Error GoTo 0

    End Function

End Module
